ParserMinimalBase
Date: 2016-12-03

com.fasterxml.jackson.core.base

## Class ParserMinimalBase

- java.lang.Object
- - com.fasterxml.jackson.core.JsonParser
  - - com.fasterxml.jackson.core.base.ParserMinimalBase

- All Implemented Interfaces:
    Versioned, java.io.Closeable, java.lang.AutoCloseable
  Direct Known Subclasses:
    ParserBase

      public abstract class ParserMinimalBase
      extends JsonParser

  Intermediate base class used by all Jackson `JsonParser` implementations, but does not add any additional fields that depend on particular method of obtaining input.

  Note that 'minimal' here mostly refers to minimal number of fields (size) and functionality that is specific to certain types of parser implementations; but not necessarily to number of methods.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.core.JsonParser

      `JsonParser.Feature, JsonParser.NumberType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JsonToken` | `_currToken` Last token retrieved via `nextToken()`, if any.
    `protected JsonToken` | `_lastClearedToken` Last cleared token, if any: that is, value that was in effect when `clearCurrentToken()` was called.
    `protected static int` | `INT_BACKSLASH`
    `protected static int` | `INT_COLON`
    `protected static int` | `INT_COMMA`
    `protected static int` | `INT_CR`
    `protected static int` | `INT_e`
    `protected static int` | `INT_E`
    `protected static int` | `INT_HASH`
    `protected static int` | `INT_LBRACKET`
    `protected static int` | `INT_LCURLY`
    `protected static int` | `INT_LF`
    `protected static int` | `INT_PERIOD`
    `protected static int` | `INT_QUOTE`
    `protected static int` | `INT_RBRACKET`
    `protected static int` | `INT_RCURLY`
    `protected static int` | `INT_SLASH`
    `protected static int` | `INT_SPACE`
    `protected static int` | `INT_TAB`

    - ### Fields inherited from class com.fasterxml.jackson.core.JsonParser

      `_features, _requestPayload`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ParserMinimalBase()`
    `protected` | `ParserMinimalBase(int features)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static java.lang.String` | `_ascii(byte[] b)`
    `protected static byte[]` | `_asciiBytes(java.lang.String str)`
    `protected JsonParseException` | `_constructError(java.lang.String msg, java.lang.Throwable t)`
    `protected void` | `_decodeBase64(java.lang.String str, ByteArrayBuilder builder, Base64Variant b64variant)` Helper method that can be used for base64 decoding in cases where encoded content has already been read as a String.
    `protected static java.lang.String` | `_getCharDesc(int ch)`
    `protected abstract void` | `_handleEOF()` Method sub-classes need to implement
    `protected char` | `_handleUnrecognizedCharacterEscape(char ch)`
    `protected boolean` | `_hasTextualNull(java.lang.String value)` Helper method used to determine whether we are currently pointing to a String value of "null" (NOT a null token); and, if so, that parser is to recognize and return it similar to if it was real null token.
    `protected void` | `_reportError(java.lang.String msg)`
    `protected void` | `_reportInvalidEOF()`
    `protected void` | `_reportInvalidEOF(java.lang.String msg)` Deprecated. Since 2.8 use `_reportInvalidEOF(String, JsonToken)` instead
    `protected void` | `_reportInvalidEOF(java.lang.String msg, JsonToken currToken)`
    `protected void` | `_reportInvalidEOFInValue()` Deprecated. Since 2.8 use `_reportInvalidEOF(String, JsonToken)` instead
    `protected void` | `_reportInvalidEOFInValue(JsonToken type)`
    `protected void` | `_reportMissingRootWS(int ch)`
    `protected void` | `_reportUnexpectedChar(int ch, java.lang.String comment)`
    `protected void` | `_throwInternal()`
    `protected void` | `_throwInvalidSpace(int i)`
    `protected void` | `_throwUnquotedSpace(int i, java.lang.String ctxtDesc)` Method called to report a problem with unquoted control character.
    `protected void` | `_wrapError(java.lang.String msg, java.lang.Throwable t)`
    `void` | `clearCurrentToken()` Method called to "consume" the current token by effectively removing it so that `JsonParser.hasCurrentToken()` returns false, and `JsonParser.getCurrentToken()` null).
    `abstract void` | `close()` Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled.
    `JsonToken` | `currentToken()` Accessor to find which token parser currently points to, if any; null will be returned if none.
    `int` | `currentTokenId()` Method similar to `JsonParser.getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).
    `abstract byte[]` | `getBinaryValue(Base64Variant b64variant)` Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value.
    `abstract java.lang.String` | `getCurrentName()` Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `JsonParser.getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.
    `JsonToken` | `getCurrentToken()` Alias for `JsonParser.currentToken()`, will be deprecated in Jackson 2.9
    `int` | `getCurrentTokenId()` Alias for `JsonParser.currentTokenId()`, will be deprecated in Jackson 2.9
    `JsonToken` | `getLastClearedToken()` Method that can be called to get the last token that was cleared using `JsonParser.clearCurrentToken()`.
    `abstract JsonStreamContext` | `getParsingContext()` Method that can be used to access current parsing context reader is in.
    `abstract java.lang.String` | `getText()` Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null.
    `abstract char[]` | `getTextCharacters()` Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information.
    `abstract int` | `getTextLength()` Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
    `abstract int` | `getTextOffset()` Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
    `boolean` | `getValueAsBoolean(boolean defaultValue)` Method that will try to convert value of current token to a boolean.
    `double` | `getValueAsDouble(double defaultValue)` Method that will try to convert value of current token to a Java double.
    `int` | `getValueAsInt()` Method that will try to convert value of current token to a int.
    `int` | `getValueAsInt(int defaultValue)` Method that will try to convert value of current token to a int.
    `long` | `getValueAsLong()` Method that will try to convert value of current token to a long.
    `long` | `getValueAsLong(long defaultValue)` Method that will try to convert value of current token to a long.
    `java.lang.String` | `getValueAsString()` Method that will try to convert value of current token to a `String`.
    `java.lang.String` | `getValueAsString(java.lang.String defaultValue)` Method that will try to convert value of current token to a `String`.
    `boolean` | `hasCurrentToken()` Method for checking whether parser currently points to a token (and data for that token is available).
    `abstract boolean` | `hasTextCharacters()` Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.
    `boolean` | `hasToken(JsonToken t)` Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.
    `boolean` | `hasTokenId(int id)` Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.
    `abstract boolean` | `isClosed()` Method that can be called to determine whether this parser is closed or not.
    `boolean` | `isExpectedStartArrayToken()` Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected.
    `boolean` | `isExpectedStartObjectToken()` Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.
    `abstract JsonToken` | `nextToken()` Main iteration method, which will advance stream enough to determine type of the next token, if any.
    `JsonToken` | `nextValue()` Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers).
    `abstract void` | `overrideCurrentName(java.lang.String name)` Method that can be used to change what is considered to be the current (field) name.
    `JsonParser` | `skipChildren()` Method that will skip all child tokens of an array or object token that the parser currently points to, iff stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`.

    - ### Methods inherited from class com.fasterxml.jackson.core.JsonParser

      `_codec, _constructError, _reportUnsupportedOperation, canReadObjectId, canReadTypeId, canUseSchema, configure, disable, enable, finishToken, getBigIntegerValue, getBinaryValue, getBooleanValue, getByteValue, getCodec, getCurrentLocation, getCurrentValue, getDecimalValue, getDoubleValue, getEmbeddedObject, getFeatureMask, getFloatValue, getFormatFeatures, getInputSource, getIntValue, getLongValue, getNumberType, getNumberValue, getObjectId, getSchema, getShortValue, getText, getTokenLocation, getTypeId, getValueAsBoolean, getValueAsDouble, isEnabled, nextBooleanValue, nextFieldName, nextFieldName, nextIntValue, nextLongValue, nextTextValue, overrideFormatFeatures, overrideStdFeatures, readBinaryValue, readBinaryValue, readValueAs, readValueAs, readValueAsTree, readValuesAs, readValuesAs, releaseBuffered, releaseBuffered, requiresCustomCodec, setCodec, setCurrentValue, setFeatureMask, setRequestPayloadOnError, setRequestPayloadOnError, setRequestPayloadOnError, setSchema, version`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### INT_TAB

          protected static final int INT_TAB

      See Also:
        Constant Field Values

    - #### INT_LF

          protected static final int INT_LF

      See Also:
        Constant Field Values

    - #### INT_CR

          protected static final int INT_CR

      See Also:
        Constant Field Values

    - #### INT_SPACE

          protected static final int INT_SPACE

      See Also:
        Constant Field Values

    - #### INT_LBRACKET

          protected static final int INT_LBRACKET

      See Also:
        Constant Field Values

    - #### INT_RBRACKET

          protected static final int INT_RBRACKET

      See Also:
        Constant Field Values

    - #### INT_LCURLY

          protected static final int INT_LCURLY

      See Also:
        Constant Field Values

    - #### INT_RCURLY

          protected static final int INT_RCURLY

      See Also:
        Constant Field Values

    - #### INT_QUOTE

          protected static final int INT_QUOTE

      See Also:
        Constant Field Values

    - #### INT_BACKSLASH

          protected static final int INT_BACKSLASH

      See Also:
        Constant Field Values

    - #### INT_SLASH

          protected static final int INT_SLASH

      See Also:
        Constant Field Values

    - #### INT_COLON

          protected static final int INT_COLON

      See Also:
        Constant Field Values

    - #### INT_COMMA

          protected static final int INT_COMMA

      See Also:
        Constant Field Values

    - #### INT_HASH

          protected static final int INT_HASH

      See Also:
        Constant Field Values

    - #### INT_PERIOD

          protected static final int INT_PERIOD

      See Also:
        Constant Field Values

    - #### INT_e

          protected static final int INT_e

      See Also:
        Constant Field Values

    - #### INT_E

          protected static final int INT_E

      See Also:
        Constant Field Values

    - #### _currToken

          protected JsonToken _currToken

      Last token retrieved via `nextToken()`, if any. Null before the first call to `nextToken()`, as well as if token has been explicitly cleared

    - #### _lastClearedToken

          protected JsonToken _lastClearedToken

      Last cleared token, if any: that is, value that was in effect when `clearCurrentToken()` was called.

  - ### Constructor Detail

    - #### ParserMinimalBase

          protected ParserMinimalBase()

    - #### ParserMinimalBase

          protected ParserMinimalBase(int features)

  - ### Method Detail

    - #### nextToken

          public abstract JsonToken nextToken()
                                       throws java.io.IOException

      Description copied from class: `JsonParser`
      Main iteration method, which will advance stream enough to determine type of the next token, if any. If none remaining (stream has no content other than possible white space before ending), null will be returned.
      Specified by:
        `nextToken` in class `JsonParser`
      Returns:
        Next token from the stream, if any found, or null to indicate end-of-input
      Throws:
        `java.io.IOException`

    - #### currentToken

          public JsonToken currentToken()

      Description copied from class: `JsonParser`
      Accessor to find which token parser currently points to, if any; null will be returned if none. If return value is non-null, data associated with the token is available via other accessor methods.
      Overrides:
        `currentToken` in class `JsonParser`
      Returns:
        Type of the token this parser currently points to, if any: null before any tokens have been read, and after end-of-input has been encountered, as well as if the current token has been explicitly cleared.

    - #### currentTokenId

          public int currentTokenId()

      Description copied from class: `JsonParser`
      Method similar to `JsonParser.getCurrentToken()` but that returns an `int` instead of `JsonToken` (enum value).

      Use of int directly is typically more efficient on switch statements, so this method may be useful when building low-overhead codecs. Note, however, that effect may not be big enough to matter: make sure to profile performance before deciding to use this method.

      Overrides:
        `currentTokenId` in class `JsonParser`
      Returns:
        `int` matching one of constants from `JsonTokenId`.

    - #### getCurrentToken

          public JsonToken getCurrentToken()

      Description copied from class: `JsonParser`
      Alias for `JsonParser.currentToken()`, will be deprecated in Jackson 2.9
      Specified by:
        `getCurrentToken` in class `JsonParser`

    - #### getCurrentTokenId

          public int getCurrentTokenId()

      Description copied from class: `JsonParser`
      Alias for `JsonParser.currentTokenId()`, will be deprecated in Jackson 2.9
      Specified by:
        `getCurrentTokenId` in class `JsonParser`

    - #### hasCurrentToken

          public boolean hasCurrentToken()

      Description copied from class: `JsonParser`
      Method for checking whether parser currently points to a token (and data for that token is available). Equivalent to check for `parser.getCurrentToken() != null`.
      Specified by:
        `hasCurrentToken` in class `JsonParser`
      Returns:
        True if the parser just returned a valid token via `JsonParser.nextToken()`; false otherwise (parser was just constructed, encountered end-of-input and returned null from `JsonParser.nextToken()`, or the token has been consumed)

    - #### hasTokenId

          public boolean hasTokenId(int id)

      Description copied from class: `JsonParser`
      Method that is functionally equivalent to: `return currentTokenId() == id` but may be more efficiently implemented.

      Note that no traversal or conversion is performed; so in some cases calling method like `JsonParser.isExpectedStartArrayToken()` is necessary instead.

      Specified by:
        `hasTokenId` in class `JsonParser`

    - #### hasToken

          public boolean hasToken(JsonToken t)

      Description copied from class: `JsonParser`
      Method that is functionally equivalent to: `return currentToken() == t` but may be more efficiently implemented.

      Note that no traversal or conversion is performed; so in some cases calling method like `JsonParser.isExpectedStartArrayToken()` is necessary instead.

      Specified by:
        `hasToken` in class `JsonParser`

    - #### isExpectedStartArrayToken

          public boolean isExpectedStartArrayToken()

      Description copied from class: `JsonParser`
      Specialized accessor that can be used to verify that the current token indicates start array (usually meaning that current token is `JsonToken.START_ARRAY`) when start array is expected. For some specialized parsers this can return true for other cases as well; this is usually done to emulate arrays in cases underlying format is ambiguous (XML, for example, has no format-level difference between Objects and Arrays; it just has elements).

      Default implementation is equivalent to:

             currentToken() == JsonToken.START_ARRAY

      but may be overridden by custom parser implementations.
      Overrides:
        `isExpectedStartArrayToken` in class `JsonParser`
      Returns:
        True if the current token can be considered as a start-array marker (such `JsonToken.START_ARRAY`); false if not.

    - #### isExpectedStartObjectToken

          public boolean isExpectedStartObjectToken()

      Description copied from class: `JsonParser`
      Similar to `JsonParser.isExpectedStartArrayToken()`, but checks whether stream currently points to `JsonToken.START_OBJECT`.
      Overrides:
        `isExpectedStartObjectToken` in class `JsonParser`

    - #### nextValue

          public JsonToken nextValue()
                              throws java.io.IOException

      Description copied from class: `JsonParser`
      Iteration method that will advance stream enough to determine type of the next token that is a value type (including JSON Array and Object start/end markers). Or put another way, nextToken() will be called once, and if `JsonToken.FIELD_NAME` is returned, another time to get the value for the field. Method is most useful for iterating over value entries of JSON objects; field name will still be available by calling `JsonParser.getCurrentName()` when parser points to the value.
      Specified by:
        `nextValue` in class `JsonParser`
      Returns:
        Next non-field-name token from the stream, if any found, or null to indicate end-of-input (or, for non-blocking parsers, `JsonToken.NOT_AVAILABLE` if no tokens were available yet)
      Throws:
        `java.io.IOException`

    - #### skipChildren

          public JsonParser skipChildren()
                                  throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will skip all child tokens of an array or object token that the parser currently points to, iff stream points to `JsonToken.START_OBJECT` or `JsonToken.START_ARRAY`. If not, it will do nothing. After skipping, stream will point to matching `JsonToken.END_OBJECT` or `JsonToken.END_ARRAY` (possibly skipping nested pairs of START/END OBJECT/ARRAY tokens as well as value tokens). The idea is that after calling this method, application will call `JsonParser.nextToken()` to point to the next available token, if any.
      Specified by:
        `skipChildren` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### _handleEOF

          protected abstract void _handleEOF()
                                      throws JsonParseException

      Method sub-classes need to implement
      Throws:
        `JsonParseException`

    - #### getCurrentName

          public abstract java.lang.String getCurrentName()
                                                   throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that can be called to get the name associated with the current token: for `JsonToken.FIELD_NAME`s it will be the same as what `JsonParser.getText()` returns; for field values it will be preceding field name; and for others (array values, root-level values) null.
      Specified by:
        `getCurrentName` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### close

          public abstract void close()
                              throws java.io.IOException

      Description copied from class: `JsonParser`
      Closes the parser so that no further iteration or data access can be made; will also close the underlying input source if parser either owns the input source, or feature `JsonParser.Feature.AUTO_CLOSE_SOURCE` is enabled. Whether parser owns the input source depends on factory method that was used to construct instance (so check `JsonFactory` for details, but the general idea is that if caller passes in closable resource (such as `InputStream` or `Reader`) parser does NOT own the source; but if it passes a reference (such as `File` or `URL` and creates stream or reader it does own them.
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### isClosed

          public abstract boolean isClosed()

      Description copied from class: `JsonParser`
      Method that can be called to determine whether this parser is closed or not. If it is closed, no new tokens can be retrieved by calling `JsonParser.nextToken()` (and the underlying stream may be closed). Closing may be due to an explicit call to `JsonParser.close()` or because parser has encountered end of input.
      Specified by:
        `isClosed` in class `JsonParser`

    - #### getParsingContext

          public abstract JsonStreamContext getParsingContext()

      Description copied from class: `JsonParser`
      Method that can be used to access current parsing context reader is in. There are 3 different types: root, array and object contexts, with slightly different available information. Contexts are hierarchically nested, and can be used for example for figuring out part of the input document that correspond to specific array or object (for highlighting purposes, or error reporting). Contexts can also be used for simple xpath-like matching of input, if so desired.
      Specified by:
        `getParsingContext` in class `JsonParser`

    - #### clearCurrentToken

          public void clearCurrentToken()

      Description copied from class: `JsonParser`
      Method called to "consume" the current token by effectively removing it so that `JsonParser.hasCurrentToken()` returns false, and `JsonParser.getCurrentToken()` null). Cleared token value can still be accessed by calling `JsonParser.getLastClearedToken()` (if absolutely needed), but usually isn't.

      Method was added to be used by the optional data binder, since it has to be able to consume last token used for binding (so that it will not be used again).

      Specified by:
        `clearCurrentToken` in class `JsonParser`

    - #### getLastClearedToken

          public JsonToken getLastClearedToken()

      Description copied from class: `JsonParser`
      Method that can be called to get the last token that was cleared using `JsonParser.clearCurrentToken()`. This is not necessarily the latest token read. Will return null if no tokens have been cleared, or if parser has been closed.
      Specified by:
        `getLastClearedToken` in class `JsonParser`

    - #### overrideCurrentName

          public abstract void overrideCurrentName(java.lang.String name)

      Description copied from class: `JsonParser`
      Method that can be used to change what is considered to be the current (field) name. May be needed to support non-JSON data formats or unusual binding conventions; not needed for typical processing.

      Note that use of this method should only be done as sort of last resort, as it is a work-around for regular operation.

      Specified by:
        `overrideCurrentName` in class `JsonParser`
      Parameters:
        `name` - Name to use as the current name; may be null.

    - #### getText

          public abstract java.lang.String getText()
                                            throws java.io.IOException

      Description copied from class: `JsonParser`
      Method for accessing textual representation of the current token; if no current token (before first call to `JsonParser.nextToken()`, or after encountering end-of-input), returns null. Method can be called for any token type.
      Specified by:
        `getText` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getTextCharacters

          public abstract char[] getTextCharacters()
                                            throws java.io.IOException

      Description copied from class: `JsonParser`
      Method similar to `JsonParser.getText()`, but that will return underlying (unmodifiable) character array that contains textual value, instead of constructing a String object to contain this information. Note, however, that:
      - Textual contents are not guaranteed to start at index 0 (rather, call `JsonParser.getTextOffset()`) to know the actual offset
      - Length of textual contents may be less than the length of returned buffer: call `JsonParser.getTextLength()` for actual length of returned content.

      Note that caller MUST NOT modify the returned character array in any way -- doing so may corrupt current parser state and render parser instance useless.

      The only reason to call this method (over `JsonParser.getText()`) is to avoid construction of a String object (which will make a copy of contents).

      Specified by:
        `getTextCharacters` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### hasTextCharacters

          public abstract boolean hasTextCharacters()

      Description copied from class: `JsonParser`
      Method that can be used to determine whether calling of `JsonParser.getTextCharacters()` would be the most efficient way to access textual content for the event parser currently points to.

      Default implementation simply returns false since only actual implementation class has knowledge of its internal buffering state. Implementations are strongly encouraged to properly override this method, to allow efficient copying of content by other code.

      Specified by:
        `hasTextCharacters` in class `JsonParser`
      Returns:
        True if parser currently has character array that can be efficiently returned via `JsonParser.getTextCharacters()`; false means that it may or may not exist

    - #### getTextLength

          public abstract int getTextLength()
                                     throws java.io.IOException

      Description copied from class: `JsonParser`
      Accessor used with `JsonParser.getTextCharacters()`, to know length of String stored in returned buffer.
      Specified by:
        `getTextLength` in class `JsonParser`
      Returns:
        Number of characters within buffer returned by `JsonParser.getTextCharacters()` that are part of textual content of the current token.
      Throws:
        `java.io.IOException`

    - #### getTextOffset

          public abstract int getTextOffset()
                                     throws java.io.IOException

      Description copied from class: `JsonParser`
      Accessor used with `JsonParser.getTextCharacters()`, to know offset of the first text content character within buffer.
      Specified by:
        `getTextOffset` in class `JsonParser`
      Returns:
        Offset of the first character within buffer returned by `JsonParser.getTextCharacters()` that is part of textual content of the current token.
      Throws:
        `java.io.IOException`

    - #### getBinaryValue

          public abstract byte[] getBinaryValue(Base64Variant b64variant)
                                         throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that can be used to read (and consume -- results may not be accessible using other methods after the call) base64-encoded binary data included in the current textual JSON value. It works similar to getting String value via `JsonParser.getText()` and decoding result (except for decoding part), but should be significantly more performant.

      Note that non-decoded textual contents of the current token are not guaranteed to be accessible after this method is called. Current implementation, for example, clears up textual content during decoding. Decoded binary content, however, will be retained until parser is advanced to the next event.

      Specified by:
        `getBinaryValue` in class `JsonParser`
      Parameters:
        `b64variant` - Expected variant of base64 encoded content (see `Base64Variants` for definitions of "standard" variants).
      Returns:
        Decoded binary data
      Throws:
        `java.io.IOException`

    - #### getValueAsBoolean

          public boolean getValueAsBoolean(boolean defaultValue)
                                    throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a boolean. JSON booleans map naturally; integer numbers other than 0 map to true, and 0 maps to false and Strings 'true' and 'false' map to corresponding values.

      If representation can not be converted to a boolean value (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsBoolean` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getValueAsInt

          public int getValueAsInt()
                            throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

      If representation can not be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsInt` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getValueAsInt

          public int getValueAsInt(int defaultValue)
                            throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a int. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

      If representation can not be converted to an int (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsInt` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getValueAsLong

          public long getValueAsLong()
                              throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

      If representation can not be converted to an int (including structured type markers like start/end Object/Array) default value of 0 will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsLong` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getValueAsLong

          public long getValueAsLong(long defaultValue)
                              throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a long. Numbers are coerced using default Java rules; booleans convert to 0 (false) and 1 (true), and Strings are parsed using default Java language integer parsing rules.

      If representation can not be converted to an int (including structured type markers like start/end Object/Array) specified def will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsLong` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getValueAsDouble

          public double getValueAsDouble(double defaultValue)
                                  throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a Java double. Numbers are coerced using default Java rules; booleans convert to 0.0 (false) and 1.0 (true), and Strings are parsed using default Java language integer parsing rules.

      If representation can not be converted to an int (including structured types like Objects and Arrays), specified def will be returned; no exceptions are thrown.

      Overrides:
        `getValueAsDouble` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getValueAsString

          public java.lang.String getValueAsString()
                                            throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), default value of null will be returned; no exceptions are thrown.
      Overrides:
        `getValueAsString` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### getValueAsString

          public java.lang.String getValueAsString(java.lang.String defaultValue)
                                            throws java.io.IOException

      Description copied from class: `JsonParser`
      Method that will try to convert value of current token to a `String`. JSON Strings map naturally; scalar values get converted to their textual representation. If representation can not be converted to a String value (including structured types like Objects and Arrays and null token), specified default value will be returned; no exceptions are thrown.
      Specified by:
        `getValueAsString` in class `JsonParser`
      Throws:
        `java.io.IOException`

    - #### _decodeBase64

          protected void _decodeBase64(java.lang.String str,
                           ByteArrayBuilder builder,
                           Base64Variant b64variant)
                                throws java.io.IOException

      Helper method that can be used for base64 decoding in cases where encoded content has already been read as a String.
      Throws:
        `java.io.IOException`

    - #### _hasTextualNull

          protected boolean _hasTextualNull(java.lang.String value)

      Helper method used to determine whether we are currently pointing to a String value of "null" (NOT a null token); and, if so, that parser is to recognize and return it similar to if it was real null token.
      Since:
        2.3

    - #### _reportUnexpectedChar

          protected void _reportUnexpectedChar(int ch,
                                   java.lang.String comment)
                                        throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _reportInvalidEOF

          protected void _reportInvalidEOF()
                                    throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _reportInvalidEOFInValue

          protected void _reportInvalidEOFInValue(JsonToken type)
                                           throws JsonParseException

      Throws:
        `JsonParseException`
      Since:
        2.8

    - #### _reportInvalidEOF

          protected void _reportInvalidEOF(java.lang.String msg,
                               JsonToken currToken)
                                    throws JsonParseException

      Throws:
        `JsonParseException`
      Since:
        2.8

    - #### _reportInvalidEOFInValue

          @Deprecated
          protected void _reportInvalidEOFInValue()
                                           throws JsonParseException

      Deprecated. Since 2.8 use `_reportInvalidEOF(String, JsonToken)` instead
      Throws:
        `JsonParseException`

    - #### _reportInvalidEOF

          @Deprecated
          protected void _reportInvalidEOF(java.lang.String msg)
                                    throws JsonParseException

      Deprecated. Since 2.8 use `_reportInvalidEOF(String, JsonToken)` instead
      Throws:
        `JsonParseException`

    - #### _reportMissingRootWS

          protected void _reportMissingRootWS(int ch)
                                       throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _throwInvalidSpace

          protected void _throwInvalidSpace(int i)
                                     throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _throwUnquotedSpace

          protected void _throwUnquotedSpace(int i,
                                 java.lang.String ctxtDesc)
                                      throws JsonParseException

      Method called to report a problem with unquoted control character. Note: starting with version 1.4, it is possible to suppress exception by enabling `JsonParser.Feature.ALLOW_UNQUOTED_CONTROL_CHARS`.
      Throws:
        `JsonParseException`

    - #### _handleUnrecognizedCharacterEscape

          protected char _handleUnrecognizedCharacterEscape(char ch)
                                                     throws JsonProcessingException

      Throws:
        `JsonProcessingException`

    - #### _getCharDesc

          protected static final java.lang.String _getCharDesc(int ch)

    - #### _reportError

          protected final void _reportError(java.lang.String msg)
                                     throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _wrapError

          protected final void _wrapError(java.lang.String msg,
                        java.lang.Throwable t)
                                   throws JsonParseException

      Throws:
        `JsonParseException`

    - #### _throwInternal

          protected final void _throwInternal()

    - #### _constructError

          protected final JsonParseException _constructError(java.lang.String msg,
                                           java.lang.Throwable t)

    - #### _asciiBytes

          protected static byte[] _asciiBytes(java.lang.String str)

    - #### _ascii

          protected static java.lang.String _ascii(byte[] b)